diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-mlo-test.cc ns-3.45/src/wifi/test/wifi-mlo-test.cc
--- ns-3.44/src/wifi/test/wifi-mlo-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-mlo-test.cc	2025-06-01 20:34:45.639702300 -0700
@@ -264,11 +264,13 @@
     RunOne("Move all links to a new set of IDs", 2, {{0, 2}, {1, 3}}, {{2, 0}, {3, 1}});
 }
 
-AidAssignmentTest::AidAssignmentTest(const std::vector<std::set<uint8_t>>& linkIds)
+AidAssignmentTest::AidAssignmentTest(const std::vector<std::set<uint8_t>>& linkIds,
+                                     WifiAssocType assocType)
     : TestCase("Test the assignment of AIDs"),
       m_linkChannels({"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}"}),
       m_linkIds(linkIds),
-      m_expectedAid(1) // AID for first station
+      m_assocType(assocType),
+      m_expectedAid(1) // AID for first station (to be updated in case of AP MLD)
 {
 }
 
@@ -332,7 +334,9 @@
                     "Ssid", // first non-AP STA/MLD only starts associating
                     SsidValue(Ssid(m_staDevices.GetN() == 0 ? "ns-3-ssid" : "default")),
                     "ActiveProbing",
-                    BooleanValue(false));
+                    BooleanValue(false),
+                    "AssocType",
+                    EnumValue(m_assocType));
 
         auto staNode = CreateObject<Node>();
         auto staDevice = wifi.Install(phyHelper, mac, staNode);
@@ -359,12 +363,16 @@
             "Assoc",
             MakeCallback(&AidAssignmentTest::SetSsid, this).Bind(DynamicCast<StaWifiMac>(mac)));
     }
+
+    auto apMac = StaticCast<ApWifiMac>(StaticCast<WifiNetDevice>(apDevice.Get(0))->GetMac());
+    m_expectedAid = m_startAid = apMac->GetNextAssociationId();
 }
 
 void
 AidAssignmentTest::SetSsid(Ptr<StaWifiMac> staMac, Mac48Address /* apAddr */)
 {
     const auto aid = staMac->GetAssociationId();
+    std::size_t index = aid - m_startAid;
 
     std::stringstream linksStr;
     const auto setupLinks = staMac->GetSetupLinkIds();
@@ -374,21 +382,21 @@
                        << linksStr.str());
 
     NS_TEST_EXPECT_MSG_EQ(aid, m_expectedAid, "Unexpected AID for STA " << staMac->GetAddress());
-    // For non-AP MLDs, check that the requested links have been setup (for non-AP STAs, link ID
-    // as seen by the non-AP STAs is always zero and could not match link ID as seen by the AP MLD)
-    if (m_linkIds.at(aid - 1).size() > 1)
-    {
-        NS_TEST_EXPECT_MSG_EQ((staMac->GetSetupLinkIds() == m_linkIds.at(aid - 1)),
-                              true,
-                              "Unexpected set of setup links " << linksStr.str());
-    }
 
-    if (m_expectedAid < m_staDevices.GetN())
+    // if ML setup is performed, check that the requested links have been setup; otherwise, link 0
+    // only is setup
+    const auto expectedLinks =
+        (m_assocType == WifiAssocType::ML_SETUP ? m_linkIds.at(index)
+                                                : std::set{SINGLE_LINK_OP_ID});
+
+    NS_TEST_EXPECT_MSG_EQ((staMac->GetSetupLinkIds() == expectedLinks),
+                          true,
+                          "Unexpected set of setup links " << linksStr.str());
+
+    if (++index < m_staDevices.GetN())
     {
         // let the next STA associate with the AP
-        StaticCast<WifiNetDevice>(m_staDevices.Get(m_expectedAid))
-            ->GetMac()
-            ->SetSsid(Ssid("ns-3-ssid"));
+        StaticCast<WifiNetDevice>(m_staDevices.Get(index))->GetMac()->SetSsid(Ssid("ns-3-ssid"));
         ++m_expectedAid;
     }
     else
@@ -403,7 +411,9 @@
     Simulator::Stop(Seconds(5)); // simulation will stop earlier if all STAs complete association
     Simulator::Run();
 
-    NS_TEST_EXPECT_MSG_EQ(m_expectedAid, m_staDevices.GetN(), "Not all STAs completed association");
+    NS_TEST_EXPECT_MSG_EQ(m_expectedAid,
+                          m_startAid + m_staDevices.GetN() - 1,
+                          "Not all STAs completed association");
 
     for (uint32_t i = 0; i < m_staDevices.GetN(); ++i)
     {
@@ -423,8 +433,10 @@
       m_staChannels(baseParams.staChannels),
       m_apChannels(baseParams.apChannels),
       m_fixedPhyBands(baseParams.fixedPhyBands),
+      m_assocType(baseParams.assocType),
       m_staMacs(nStations),
       m_nStations(nStations),
+      m_startAid(1),
       m_lastAid(0),
       m_rxPkts(nStations + 1)
 {
@@ -643,7 +655,7 @@
 MultiLinkOperationsTestBase::DoSetup()
 {
     RngSeedManager::SetSeed(1);
-    RngSeedManager::SetRun(5);
+    RngSeedManager::SetRun(1);
     int64_t streamNumber = 30;
 
     NodeContainer wifiApNode;
@@ -680,7 +692,9 @@
                 "MaxMissedBeacons",
                 UintegerValue(1e6), // do not deassociate
                 "ActiveProbing",
-                BooleanValue(false));
+                BooleanValue(false),
+                "AssocType",
+                EnumValue(m_assocType));
 
     NetDeviceContainer staDevices = wifi.Install(staPhyHelper, mac, wifiStaNodes);
 
@@ -771,6 +785,8 @@
     m_apMac->TraceConnectWithoutContext("AssociatedSta",
                                         MakeCallback(&MultiLinkOperationsTestBase::SetSsid, this));
     m_staMacs[0]->SetSsid(Ssid("ns-3-ssid"));
+
+    m_startAid = m_apMac->GetNextAssociationId();
 }
 
 Ptr<PacketSocketClient>
@@ -803,9 +819,9 @@
     m_lastAid = aid;
 
     // make the next STA to start ML discovery & setup
-    if (aid < m_nStations)
+    if (const std::size_t count = aid - m_startAid + 1; count < m_nStations)
     {
-        m_staMacs[aid]->SetSsid(Ssid("ns-3-ssid"));
+        m_staMacs[count]->SetSsid(Ssid("ns-3-ssid"));
         return;
     }
     // stop generation of beacon frames in order to avoid interference
@@ -818,12 +834,14 @@
 MultiLinkSetupTest::MultiLinkSetupTest(const BaseParams& baseParams,
                                        WifiScanType scanType,
                                        const std::vector<uint8_t>& setupLinks,
+                                       const std::vector<uint8_t>& staSetupLinks,
                                        WifiTidToLinkMappingNegSupport apNegSupport,
                                        const std::string& dlTidToLinkMapping,
                                        const std::string& ulTidToLinkMapping,
                                        bool support160MHzOp)
     : MultiLinkOperationsTestBase("Check correctness of Multi-Link Setup", 1, baseParams),
       m_setupLinks(setupLinks),
+      m_staSetupLinks(staSetupLinks.empty() ? setupLinks : staSetupLinks),
       m_scanType(scanType),
       m_nProbeResp(0),
       m_apNegSupport(apNegSupport),
@@ -831,6 +849,9 @@
       m_ulTidLinkMappingStr(ulTidToLinkMapping),
       m_support160MHzOp(support160MHzOp)
 {
+    NS_TEST_ASSERT_MSG_EQ(m_setupLinks.size(),
+                          m_staSetupLinks.size(),
+                          "Number of setup links must be the same for AP and non-AP device");
 }
 
 void
@@ -839,13 +860,11 @@
     MultiLinkOperationsTestBase::DoSetup();
 
     m_staMacs[0]->SetAttribute("ActiveProbing", BooleanValue(m_scanType == WifiScanType::ACTIVE));
-    m_apMac->GetEhtConfiguration()->SetAttribute("TidToLinkMappingNegSupport",
-                                                 EnumValue(m_apNegSupport));
+    m_apMac->GetEhtConfiguration()->m_tidLinkMappingSupport = m_apNegSupport;
     // For non-AP MLD, it does not make sense to set the negotiation type to 0 (unless the AP MLD
     // also advertises 0) or 1 (the AP MLD is discarded if it advertises a support of 3)
     auto staEhtConfig = m_staMacs[0]->GetEhtConfiguration();
-    staEhtConfig->SetAttribute("TidToLinkMappingNegSupport",
-                               EnumValue(WifiTidToLinkMappingNegSupport::ANY_LINK_SET));
+    staEhtConfig->m_tidLinkMappingSupport = WifiTidToLinkMappingNegSupport::ANY_LINK_SET;
     staEhtConfig->SetAttribute("TidToLinkMappingDl", StringValue(m_dlTidLinkMappingStr));
     staEhtConfig->SetAttribute("TidToLinkMappingUl", StringValue(m_ulTidLinkMappingStr));
 
@@ -940,8 +959,6 @@
     // are compatible
     for (auto staMac : m_staMacs)
     {
-        staMac->GetVhtConfiguration()->SetAttribute("Support160MHzOperation",
-                                                    BooleanValue(m_support160MHzOp));
         uint8_t linkId = 0;
         for (const auto& str : m_staChannels)
         {
@@ -1209,11 +1226,18 @@
     mpdu->GetPacket()->PeekHeader(assoc);
     const auto& mle = assoc.Get<MultiLinkElement>();
 
-    if (m_apMac->GetNLinks() == 1 || m_staMacs[0]->GetNLinks() == 1)
+    if (m_apMac->GetNLinks() == 1)
     {
         NS_TEST_EXPECT_MSG_EQ(mle.has_value(),
                               false,
-                              "Multi-Link Element in Assoc Request frame from single link STA");
+                              "Multi-Link Element in Assoc Request frame to single link AP");
+    }
+    else if (m_staMacs[0]->GetAssocType() == WifiAssocType::LEGACY)
+    {
+        NS_TEST_EXPECT_MSG_EQ(
+            mle.has_value(),
+            false,
+            "Multi-Link Element in Assoc Request frame from non-AP using legacy association");
     }
     else
     {
@@ -1260,9 +1284,9 @@
     const auto& tlm = assoc.Get<TidToLinkMapping>();
 
     // A TID-to-Link Mapping IE is included in the Association Request if and only if the AP MLD
-    // and the non-AP MLD are performing ML setup (i.e., they both have multiple links) and the
-    // AP MLD advertises a non-null negotiation support type
-    if (m_apMac->GetNLinks() == 1 || m_staMacs[0]->GetNLinks() == 1 ||
+    // and the non-AP MLD are performing ML setup and the AP MLD advertises a non-null negotiation
+    // support type
+    if (m_apMac->GetNLinks() == 1 || m_staMacs[0]->GetAssocType() == WifiAssocType::LEGACY ||
         m_apNegSupport == WifiTidToLinkMappingNegSupport::NOT_SUPPORTED)
     {
         NS_TEST_EXPECT_MSG_EQ(tlm.empty(),
@@ -1340,12 +1364,20 @@
     mpdu->GetPacket()->PeekHeader(assoc);
     const auto& mle = assoc.Get<MultiLinkElement>();
 
-    if (m_apMac->GetNLinks() == 1 || m_staMacs[0]->GetNLinks() == 1)
+    if (m_apMac->GetNLinks() == 1)
+    {
+        NS_TEST_EXPECT_MSG_EQ(mle.has_value(),
+                              false,
+                              "Multi-Link Element in Assoc Response frame with single link AP");
+        return;
+    }
+
+    if (m_staMacs[0]->GetAssocType() == WifiAssocType::LEGACY)
     {
         NS_TEST_EXPECT_MSG_EQ(
             mle.has_value(),
             false,
-            "Multi-Link Element in Assoc Response frame with single link AP or single link STA");
+            "Multi-Link Element in Assoc Response frame with non-AP using legacy association");
         return;
     }
 
@@ -1399,10 +1431,12 @@
      */
     NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->IsAssociated(), true, "Expected the STA to be associated");
 
-    for (const auto linkId : m_setupLinks)
+    for (auto linkIdIter = m_setupLinks.cbegin(), staLinkIdIter = m_staSetupLinks.cbegin();
+         linkIdIter != m_setupLinks.cend();
+         ++linkIdIter, ++staLinkIdIter)
     {
-        auto staLinkId = (m_staMacs[0]->GetNLinks() > 1 ? linkId : SINGLE_LINK_OP_ID);
-        auto apLinkId = (m_apMac->GetNLinks() > 1 ? linkId : SINGLE_LINK_OP_ID);
+        auto staLinkId = *staLinkIdIter;
+        auto apLinkId = *linkIdIter;
 
         auto staAddr = m_staMacs[0]->GetFrameExchangeManager(staLinkId)->GetAddress();
         auto apAddr = m_apMac->GetFrameExchangeManager(apLinkId)->GetAddress();
@@ -1414,7 +1448,7 @@
         NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->GetFrameExchangeManager(staLinkId)->GetBssid(),
                               apAddr,
                               "Unexpected BSSID for STA link ID " << +staLinkId);
-        if (m_apMac->GetNLinks() > 1 && m_staMacs[0]->GetNLinks() > 1)
+        if (m_apMac->GetNLinks() > 1 && m_assocType == WifiAssocType::ML_SETUP)
         {
             NS_TEST_EXPECT_MSG_EQ((staRemoteMgr->GetMldAddress(apAddr) == m_apMac->GetAddress()),
                                   true,
@@ -1430,7 +1464,7 @@
                               true,
                               "Expecting STA " << staAddr << " to be associated on link "
                                                << +apLinkId);
-        if (m_apMac->GetNLinks() > 1 && m_staMacs[0]->GetNLinks() > 1)
+        if (m_apMac->GetNLinks() > 1 && m_assocType == WifiAssocType::ML_SETUP)
         {
             NS_TEST_EXPECT_MSG_EQ(
                 (apRemoteMgr->GetMldAddress(staAddr) == m_staMacs[0]->GetAddress()),
@@ -1519,8 +1553,9 @@
             }
         };
 
-    auto storedMapping = m_apMac->GetNLinks() > 1 && m_staMacs[0]->GetNLinks() > 1 &&
-                         m_apNegSupport > WifiTidToLinkMappingNegSupport::NOT_SUPPORTED;
+    auto storedMapping = (m_apMac->GetNLinks() > 1) &&
+                         (m_staMacs[0]->GetAssocType() == WifiAssocType::ML_SETUP) &&
+                         (m_apNegSupport > WifiTidToLinkMappingNegSupport::NOT_SUPPORTED);
     checkStoredMapping(m_apMac, m_staMacs[0], WifiDirection::DOWNLINK, storedMapping);
     checkStoredMapping(m_apMac, m_staMacs[0], WifiDirection::UPLINK, storedMapping);
     checkStoredMapping(m_staMacs[0], m_apMac, WifiDirection::DOWNLINK, storedMapping);
@@ -1530,35 +1565,35 @@
 void
 MultiLinkSetupTest::CheckDisabledLinks()
 {
-    if (m_apMac->GetNLinks() > 1)
-    {
-        WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE,
-                                     WIFI_UNICAST,
-                                     m_staMacs[0]->GetAddress(),
-                                     0);
-
-        for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); ++linkId)
-        {
-            auto it = std::find(m_setupLinks.cbegin(), m_setupLinks.cend(), linkId);
+    const auto legacyAssoc = (m_assocType == WifiAssocType::LEGACY || m_apMac->GetNLinks() == 1);
 
-            // the queue on the AP should have a mask if and only if the link has been setup
-            auto mask = m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, linkId);
-            NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
-                                  (it != m_setupLinks.cend()),
-                                  "Unexpected presence/absence of mask on link " << +linkId);
-        }
+    if (legacyAssoc)
+    {
+        NS_TEST_ASSERT_MSG_EQ(m_staSetupLinks.size(),
+                              1,
+                              "One link is expected to be setup with legacy association");
     }
 
-    if (m_staMacs[0]->GetNLinks() == 1)
+    for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); ++linkId)
     {
-        // no link is disabled on a single link device
-        return;
+        auto it = std::find(m_setupLinks.cbegin(), m_setupLinks.cend(), linkId);
+        auto addr =
+            (legacyAssoc
+                 ? m_staMacs[0]->GetFrameExchangeManager(m_staSetupLinks.front())->GetAddress()
+                 : m_staMacs[0]->GetAddress());
+        WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, addr, 0);
+
+        // the queue on the AP should have a mask if and only if the link has been setup
+        auto mask = m_apMac->GetMacQueueScheduler()->GetQueueLinkMask(AC_BE, queueId, linkId);
+        NS_TEST_EXPECT_MSG_EQ(mask.has_value(),
+                              (it != m_setupLinks.cend()),
+                              "Unexpected presence/absence of mask on link " << +linkId);
     }
 
     for (const auto& linkId : m_staMacs[0]->GetLinkIds())
     {
-        auto it = std::find(m_setupLinks.begin(), m_setupLinks.end(), linkId);
-        if (it == m_setupLinks.end())
+        auto it = std::find(m_staSetupLinks.begin(), m_staSetupLinks.end(), linkId);
+        if (it == m_staSetupLinks.end())
         {
             // the link has not been setup
             NS_TEST_EXPECT_MSG_EQ(m_staMacs[0]->GetWifiPhy(linkId)->GetState()->IsStateOff(),
@@ -1677,7 +1712,7 @@
         }
     }
 
-    if (m_apMac->GetNLinks() > 1 && m_staMacs[0]->GetNLinks() > 1)
+    if (m_apMac->GetNLinks() > 1 && m_assocType == WifiAssocType::ML_SETUP)
     {
         NS_TEST_EXPECT_MSG_EQ(std::count(linkSet.cbegin(), linkSet.cend(), linkId),
                               1,
@@ -2714,7 +2749,8 @@
           1,
           BaseParams{{"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
                      {"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
-                     {}}),
+                     {},
+                     WifiAssocType::ML_SETUP}),
       m_nQosDataFrames(0),
       m_errorModel(CreateObject<ListErrorModel>()),
       m_rtsCorrupted(false)
@@ -2831,7 +2867,8 @@
           1,
           BaseParams{{"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
                      {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
-                     {}}),
+                     {},
+                     WifiAssocType::ML_SETUP}),
       m_nQosDataCount(0),
       m_staErrorModel(CreateObject<ListErrorModel>())
 {
@@ -2980,20 +3017,235 @@
     Simulator::Destroy();
 }
 
+BarAfterDroppedMpduTest::BarAfterDroppedMpduTest(WifiAssocType assocType)
+    : MultiLinkOperationsTestBase("Check correct reception of the BAR sent after dropping MPDUs",
+                                  1,
+                                  BaseParams{{"{1, 0, BAND_6GHZ, 0}"},
+                                             {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
+                                             {},
+                                             assocType}),
+      m_staErrorModel(CreateObject<ListErrorModel>()),
+      m_apErrorModel(CreateObject<ListErrorModel>())
+{
+}
+
+void
+BarAfterDroppedMpduTest::DoSetup()
+{
+    // Set the frame retry limit to 1 so that QoS data frames are dropped after the first TX failure
+    Config::SetDefault("ns3::WifiMac::FrameRetryLimit", UintegerValue(1));
+    Config::SetDefault("ns3::WifiRemoteStationManager::IncrementRetryCountUnderBa",
+                       BooleanValue(true));
+
+    MultiLinkOperationsTestBase::DoSetup();
+
+    // install post reception error model on all STAs affiliated with non-AP MLD
+    for (const auto linkId : m_staMacs[0]->GetLinkIds())
+    {
+        m_staMacs[0]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(m_staErrorModel);
+    }
+    // install post reception error model on all APs affiliated with the AP MLD
+    for (const auto linkId : m_apMac->GetLinkIds())
+    {
+        m_apMac->GetWifiPhy(linkId)->SetPostReceptionErrorModel(m_apErrorModel);
+    }
+}
+
+void
+BarAfterDroppedMpduTest::Transmit(Ptr<WifiMac> mac,
+                                  uint8_t phyId,
+                                  WifiConstPsduMap psduMap,
+                                  WifiTxVector txVector,
+                                  double txPowerW)
+{
+    MultiLinkOperationsTestBase::Transmit(mac, phyId, psduMap, txVector, txPowerW);
+
+    const auto psdu = psduMap.cbegin()->second;
+    const auto& hdr = psdu->GetHeader(0);
+
+    // nothing to do before setup is completed or if this is a Beacon frame
+    if (!m_setupDone || hdr.IsBeacon())
+    {
+        return;
+    }
+
+    auto linkId = mac->GetLinkForPhy(phyId);
+    NS_TEST_ASSERT_MSG_EQ(linkId.has_value(),
+                          true,
+                          "PHY " << +phyId << " is not operating on any link");
+
+    if (!m_events.empty())
+    {
+        // check that the expected frame is being transmitted
+        NS_TEST_EXPECT_MSG_EQ(WifiMacHeader(m_events.front().hdrType).GetTypeString(),
+                              std::string(hdr.GetTypeString()),
+                              "Unexpected MAC header type for frame #" << ++m_processedEvents);
+        // perform actions/checks, if any
+        if (m_events.front().func)
+        {
+            m_events.front().func(psdu, txVector, linkId.value());
+        }
+
+        m_events.pop_front();
+    }
+}
+
+void
+BarAfterDroppedMpduTest::StartTraffic()
+{
+    m_setupDone = true;
+    InsertEvents();
+
+    PacketSocketAddress sockAddr;
+    sockAddr.SetSingleDevice(m_apMac->GetDevice()->GetIfIndex());
+    sockAddr.SetPhysicalAddress(m_staMacs[0]->GetAddress());
+    sockAddr.SetProtocol(1);
+
+    // install client application generating 2 packets of 1000 bytes on the AP MLD
+    m_apMac->GetDevice()->GetNode()->AddApplication(GetApplication(sockAddr, 2, 1000));
+}
+
+void
+BarAfterDroppedMpduTest::InsertEvents()
+{
+    // lambda returning the UIDs of all MPDUs in the given PSDU
+    auto getUids = [](Ptr<const WifiPsdu> psdu) {
+        std::list<uint64_t> uids;
+        for (const auto& mpdu : *PeekPointer(psdu))
+        {
+            uids.push_back(mpdu->GetPacket()->GetUid());
+        }
+        return uids;
+    };
+
+    // BlockAck agreement establishment (AP MLD -> non-AP STA)
+    m_events.emplace_back(WIFI_MAC_MGT_ACTION);
+    m_events.emplace_back(WIFI_MAC_CTL_ACK);
+    m_events.emplace_back(WIFI_MAC_MGT_ACTION);
+    m_events.emplace_back(WIFI_MAC_CTL_ACK);
+
+    m_events.emplace_back(
+        WIFI_MAC_QOSDATA,
+        [=, this](Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId) {
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetAddr2(),
+                                  m_apMac->GetFrameExchangeManager(linkId)->GetAddress(),
+                                  "Unexpected TA for the data frame sent by the AP");
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetNMpdus(), 2, "Expected to transmit an A-MPDU");
+
+            // corrupt all the MPDUs in the A-MPDU
+            m_staErrorModel->SetList(getUids(psdu));
+        });
+
+    // QoS data frames are dropped, thus expect a BAR to advance recipient window
+    m_events.emplace_back(
+        WIFI_MAC_CTL_BACKREQ,
+        [=, this](Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId) {
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetAddr2(),
+                                  m_apMac->GetFrameExchangeManager(linkId)->GetAddress(),
+                                  "Unexpected TA for the BlockAckReq sent by the AP");
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetAddr1(),
+                                  m_staMacs[0]->GetAddress(),
+                                  "Unexpected RA for the BlockAckReq sent by the AP");
+        });
+
+    m_events.emplace_back(
+        WIFI_MAC_CTL_BACKRESP,
+        [=, this](Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId) {
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetAddr2(),
+                                  m_staMacs[0]->GetAddress(),
+                                  "Unexpected TA for the BlockAck sent by the non-AP STA");
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetAddr1(),
+                                  m_staMacs[0]->GetBssid(linkId),
+                                  "Unexpected RA for the BlockAck sent by the non-AP STA");
+
+            // generate uplink frames
+            Simulator::Schedule(MilliSeconds(5), [=, this]() {
+                PacketSocketAddress sockAddr;
+                sockAddr.SetSingleDevice(m_staMacs[0]->GetDevice()->GetIfIndex());
+                sockAddr.SetPhysicalAddress(m_apMac->GetAddress());
+                sockAddr.SetProtocol(1);
+
+                // install client application generating 2 packets of 1000 bytes on the non-AP STA
+                m_staMacs[0]->GetDevice()->GetNode()->AddApplication(
+                    GetApplication(sockAddr, 2, 1000));
+            });
+        });
+
+    // BlockAck agreement establishment (non-AP STA -> AP MLD)
+    m_events.emplace_back(WIFI_MAC_MGT_ACTION);
+    m_events.emplace_back(WIFI_MAC_CTL_ACK);
+    m_events.emplace_back(WIFI_MAC_MGT_ACTION);
+    m_events.emplace_back(WIFI_MAC_CTL_ACK);
+
+    m_events.emplace_back(
+        WIFI_MAC_QOSDATA,
+        [=, this](Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId) {
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetAddr2(),
+                                  m_staMacs[0]->GetFrameExchangeManager(linkId)->GetAddress(),
+                                  "Unexpected TA for the data frame sent by the non-AP STA");
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetNMpdus(), 2, "Expected to transmit an A-MPDU");
+
+            // corrupt all the MPDUs in the A-MPDU
+            m_apErrorModel->SetList(getUids(psdu));
+        });
+
+    // QoS data frames are dropped, thus expect a BAR to advance recipient window
+    m_events.emplace_back(
+        WIFI_MAC_CTL_BACKREQ,
+        [=, this](Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId) {
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetAddr2(),
+                                  m_staMacs[0]->GetAddress(),
+                                  "Unexpected TA for the BlockAckReq sent by the non-AP STA");
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetAddr1(),
+                                  m_staMacs[0]->GetBssid(linkId),
+                                  "Unexpected RA for the BlockAckReq sent by the non-AP STA");
+        });
+
+    m_events.emplace_back(
+        WIFI_MAC_CTL_BACKRESP,
+        [=, this](Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId) {
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetAddr2(),
+                                  m_apMac->GetFrameExchangeManager(linkId)->GetAddress(),
+                                  "Unexpected TA for the BlockAck sent by the AP");
+            NS_TEST_EXPECT_MSG_EQ(psdu->GetAddr1(),
+                                  m_staMacs[0]->GetAddress(),
+                                  "Unexpected RA for the BlockAck sent by the AP");
+        });
+}
+
+void
+BarAfterDroppedMpduTest::DoRun()
+{
+    Simulator::Stop(m_duration);
+    Simulator::Run();
+
+    NS_TEST_EXPECT_MSG_EQ(m_events.empty(), true, "Not all events took place");
+
+    Simulator::Destroy();
+}
+
 WifiMultiLinkOperationsTestSuite::WifiMultiLinkOperationsTestSuite()
     : TestSuite("wifi-mlo", Type::UNIT)
 {
-    using ParamsTuple = std::tuple<MultiLinkOperationsTestBase::BaseParams, // base config params
-                                   std::vector<uint8_t>,           // link ID of setup links
-                                   WifiTidToLinkMappingNegSupport, // AP negotiation support
-                                   std::string,                    // DL TID-to-Link Mapping
-                                   std::string>;                   // UL TID-to-Link Mapping
+    using ParamsTuple =
+        std::tuple<MultiLinkOperationsTestBase::BaseParams, // base config params
+                   std::vector<uint8_t>, // link ID (as seen by AP device) of setup links
+                   std::vector<uint8_t>, // link ID (as seen by non-AP device) of setup links
+                   WifiTidToLinkMappingNegSupport, // AP negotiation support
+                   std::string,                    // DL TID-to-Link Mapping
+                   std::string>;                   // UL TID-to-Link Mapping
 
     AddTestCase(new GetRnrLinkInfoTest(), TestCase::Duration::QUICK);
     AddTestCase(new MldSwapLinksTest(), TestCase::Duration::QUICK);
     AddTestCase(
         new AidAssignmentTest(
-            std::vector<std::set<uint8_t>>{{0, 1, 2}, {1, 2}, {0, 1}, {0, 2}, {0}, {1}, {2}}),
+            std::vector<std::set<uint8_t>>{{0, 1, 2}, {1, 2}, {0, 1}, {0, 2}, {0}, {1}, {2}},
+            WifiAssocType::ML_SETUP),
+        TestCase::Duration::QUICK);
+    AddTestCase(
+        new AidAssignmentTest(
+            std::vector<std::set<uint8_t>>{{0, 1, 2}, {1, 2}, {0, 1}, {0, 2}, {0}, {1}, {2}},
+            WifiAssocType::LEGACY),
         TestCase::Duration::QUICK);
 
     // check that the selection of channels in ML setup accounts for the inability of a
@@ -3003,9 +3255,11 @@
             MultiLinkOperationsTestBase::BaseParams{
                 {"{42, 80, BAND_5GHZ, 2}", "{5, 40, BAND_2_4GHZ, 0}", "{7, 80, BAND_6GHZ, 0}"},
                 {"{3, 40, BAND_2_4GHZ, 0}", "{15, 160, BAND_6GHZ, 7}", "{50, 160, BAND_5GHZ, 2}"},
-                {}},
+                {},
+                WifiAssocType::ML_SETUP},
             WifiScanType::PASSIVE,
             {0, 1, 2},
+            {}, // IDs of setup links are the same for AP and non-AP devices
             WifiTidToLinkMappingNegSupport::ANY_LINK_SET,
             "",
             "",
@@ -3014,6 +3268,7 @@
 
     for (const auto& [baseParams,
                       setupLinks,
+                      staSetupLinks,
                       apNegSupport,
                       dlTidLinkMapping,
                       ulTidLinkMapping] :
@@ -3021,8 +3276,10 @@
           ParamsTuple(
               {{"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
                {"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
-               {}},
+               {},
+               WifiAssocType::ML_SETUP},
               {0, 1, 2},
+              {}, // IDs of setup links are the same for AP and non-AP devices
               WifiTidToLinkMappingNegSupport::NOT_SUPPORTED, // AP MLD does not support TID-to-Link
                                                              // Mapping negotiation
               "0,1,2,3  0,1,2;  4,5  0,1",                   // default mapping used instead
@@ -3031,8 +3288,10 @@
           // non-matching channels, matching PHY bands: setup all links
           ParamsTuple({{"{108, 0, BAND_5GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
                        {"{36, 0, BAND_5GHZ, 0}", "{120, 0, BAND_5GHZ, 0}", "{5, 0, BAND_6GHZ, 0}"},
-                       {}},
+                       {},
+                       WifiAssocType::ML_SETUP},
                       {0, 1, 2},
+                      {}, // IDs of setup links are the same for AP and non-AP devices
                       WifiTidToLinkMappingNegSupport::SAME_LINK_SET, // AP MLD does not support
                                                                      // distinct link sets for TIDs
                       "0,1,2,3  0,1,2;  4,5  0,1",                   // default mapping used instead
@@ -3040,8 +3299,10 @@
           // non-AP MLD switches band on some links to setup 3 links
           ParamsTuple({{"{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
                        {"{36, 0, BAND_5GHZ, 0}", "{9, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                       {}},
+                       {},
+                       WifiAssocType::ML_SETUP},
                       {0, 1, 2},
+                      {}, // IDs of setup links are the same for AP and non-AP devices
                       WifiTidToLinkMappingNegSupport::ANY_LINK_SET,
                       "0,1,2,3  0;  4,5,6,7  1,2", // frames of two TIDs are generated
                       "0,2,3  1,2;  1,4,5,6,7  0"  // frames of two TIDs are generated
@@ -3051,8 +3312,10 @@
           ParamsTuple(
               {{"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{8, 20, BAND_2_4GHZ, 0}"},
                {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-               {0}},
+               {0},
+               WifiAssocType::ML_SETUP},
               {0, 1},
+              {}, // IDs of setup links are the same for AP and non-AP devices
               WifiTidToLinkMappingNegSupport::SAME_LINK_SET, // AP MLD does not support distinct
                                                              // link sets for TIDs
               "0,1,2,3,4,5,6,7  0",
